<template>
  <div class="icon" v-html="svg" />
</template>

<script>
import Feather from 'feather-icons'

export default {
  name: 'SaIcon',
  props: {
    /** Name of icon. See the icons list for available names. */
    icon: {
      type: String,
      required: true
    },
    /** The sizes correspond to the preset font sizes in the Typography section
     * @values 0, 1, 2, 3, 4, 5, 6 */
    size: {
      type: String,
      default: '1'
    },
    /** Sets the icon to spin continuously (use with `loader` icon for an animated loading icon) */
    spin: {
      type: Boolean,
      default: false
    }
  },
  computed: {
    classes() {
      return [`size-${this.size}`, { spin: this.spin }]
    },
    svg() {
      return Feather.icons[this.icon].toSvg({ class: this.classes })
    }
  }
}
</script>

<style lang="scss" scoped>
.icon {
  display: inline;
  vertical-align: middle;
}

::v-deep {
  svg {
    stroke: currentColor;
    stroke-width: 2;
    stroke-linecap: round;
    stroke-linejoin: round;
    fill: none;
  }

  @each $number, $size in $font-size {
    .size-#{$number} {
      width: $size;
      height: $size;
    }
  }

  .spin {
    animation: rotate 4s infinite linear;
  }

  @keyframes rotate {
    from {
      transform: rotate(0deg);
    }
    to {
      transform: rotate(359deg);
    }
  }
}
</style>
